/* cc -O2 -o avlabik avlabik.c -lm
 */
#include "../gen/include.h"
FILE *in;

#define MAXNB 64
int NB=12;

char Line[257];
char *line=Line+1;
char key='a';
FILE *out;

char *sqrts(double x,int n)
{
  static char s[32];

  if (n<=1) return "?";
  if (x<0) return "0";
  sprintf(s,"%11.8g",sqrt(x/(n-1)));
  return s;
}

void redir(void)
{
 fgets(line,256,in); 
 if (key=='c') return;
 if (line[0]=='#') fputs(line,out); else fputs(Line,out);
}

int main(int narg,char **arg)
{
 int n,i,dummy,nd=0;
 int spow=2,std=0;
 double *r,*g,*gQ,*gq[MAXNB],*gs[MAXNB],*gss[MAXNB],rr,gg;
 int kk,check=1,jj;

 out=stdout;
 Line[0]='#';

 if (narg<2) {
   fprintf(stderr,"Average a Labik file to one block of the same structure. Call by:\n\
  avlabik FILE KEY [NB] [> AVERAGEDFILE]\n\
KEY=a: average (default)\n\
KEY=x: average + stdev as 4th column\n\
KEY=c: only # of blocks\n\
KEY=s: r g stdev, in NB increasing blocks by power of 2\n\
KEY=d: r g stdev, in NB increasing blocks by power of 10\n\
KEY=g: r g stdev, NB Gauss windows\n\
uppercase KEY = ignore bad block numbers\n\
in bash to get the # of blocks:\n\
  M=`avlabik FILE count`\n\
See also: av2corr av2gcorr\n");
   exit(0); }

 fprintf(stderr,"%s : ",arg[1]);
 in=fopen(arg[1],"rt");
 if (!in) Error(arg[1]);
 if (narg>2) key=arg[2][0];
 if (narg>3) NB=atoi(arg[3]);
 if (key=='x') key='a',std++;
 if (key=='X') key='A',std++;
 if (key<'a') key+=32,check=0;
 redir(); 
 redir(); 
 redir(); 
 redir(); 
 sscanf(line+(line[0]=='#'),"%d",&n);
 if (n<10 || n>1000000) Error("n");

 fprintf(stderr,"n=%d",n); 
 n++;
 allocarrayzero(r,n);
 allocarrayzero(g,n);
 allocarrayzero(gQ,n);
 if (key=='d') {
   key='s';
   spow=10; }
 if (key=='s') {
   int nn=n;

   loop (jj,0,NB) {
     allocarrayzero(gq[jj],nn);
     allocarrayzero(gs[jj],nn);
     allocarrayzero(gss[jj],nn);
     nn=(nn+(spow-1))/spow; }
   put(nn); }

 if (key=='g')
   loop (jj,0,NB) {
     allocarrayzero(gq[jj],n);
     allocarrayzero(gs[jj],n);
     allocarrayzero(gss[jj],n); }

 for (;;) {

   loop (i,0,n) {
     if (!fgets(line,256,in)) Error("unexpected EOF");
     sscanf(line,"%d%lf%lf",&kk,&rr,&gg);
     if (key!='a') gg*=Sqr(rr);
     if (i!=kk) Error("data shifted (k)");
     if (!nd) r[i]=rr;
     else if (r[i]!=rr) {
       sprintf(line,"data shifted block=%d %.12g %.12g",nd+1,r[i],rr);
       Error(line); }
     if (key=='s') {
       int m=1;

       loop (jj,0,NB) {
         int ii=i/m;

         gs[jj][ii]+=gg;
         if (i%m==m-1) {
           gss[jj][ii]+=gs[jj][ii];
           gq[jj][ii]+=Sqr(gs[jj][ii]);
           gs[jj][ii]=0; }
         m*=spow; }
       }
     else if (key=='g') g[i]=gg;
     else g[i]+=gg,gQ[i]+=gg*gg; }

   if (key=='g')
     loop (jj,0,NB) {
       double ww=exp((jj-1)*0.34657359);
       double w=-0.5/Sqr(ww);
       int i,j;

       if (jj==0) ww=0;

       fprintf(stderr,"%d:%d   \r",nd,jj);

       loop (i,0,n) {
         double x=0,norm=0;
         int dn=5.6*ww,n1=i+dn+1,n0=i-dn;

         if (n0<0) n0=0;
         if (n1>=n) n1=n;
         if (jj==0)
	   x=g[i],norm=1;
         else {
           loop (j,n0,n1) {
           double y=exp(Sqr(i-j)*w);
           x+=g[j]*y;
           norm+=y*y; }
           x/=sqrt(norm); }
         gss[jj][i]+=x;
         gq[jj][i]+=Sqr(x); }
       }

  nd++;
  if (!fgets(line,256,in)) break;
  if (!fgets(line,256,in)) break;
  if (!fgets(line,256,in)) break;
  i=-1;
  sscanf(line+(line[0]=='#'),"%d%d%d%d",&dummy,&dummy,&dummy,&i);
  if (i==-1) Error("garbage at EOF");
  if (i!=nd+1) if (check) Error("block count");
  if (!fgets(line,256,in)) break; }

 fprintf(stderr," %2d blocks averaged\n",nd);

 if (key=='c') printf("%d\n",nd);
 else if (key=='s') {
   int nn=n,m=1;

   loop (jj,0,NB) {
     out=fopen(string("block%d.std",jj),"wt");

     loop (i,0,nn)
       fprintf(out,"%11.8g %11.8g %11.8g %11.8g\n",
               r[i*m+m/2],gss[jj][i]/nd,
               sqrt((gq[jj][i]/nd-Sqr(gss[jj][i]/nd))/(nd-1)),
               sqrt((gq[jj][i]/nd-Sqr(gss[jj][i]/nd))/(nd-1))/sqrt(m)
               );
     m*=spow;
     nn/=spow; 
     fclose(out); } }
 else if (key=='g') {

   loop (jj,0,NB) {
     out=fopen(string("gauss%d.std",jj),"wt");

     loop (i,0,n)
       fprintf(out,"%11.8g %11.8g %11.8g %11.8g\n",
               r[i],gss[jj][i]/nd,
               sqrt((gq[jj][i]/nd-Sqr(gss[jj][i]/nd))/(nd-1)),
               sqrt((gq[jj][i]/nd-Sqr(gss[jj][i]/nd))/(nd-1))/r[i]
               );
     fclose(out); } }
 else if (std)
   loop (i,0,n) fprintf(out,"%4d %8.4f %13.9f %s\n",i,r[i],g[i]/nd,
			sqrts(gQ[i]/nd-Sqr(g[i]/nd),nd));
 else
   loop (i,0,n) fprintf(out,"%4d %8.4f %13.9f\n",i,r[i],g[i]/nd);

 return 0;
}
