struct rdf_s {
  real cutoff,proggrid,oldsum;
#ifdef SWPERT
  int nsw,lag;
  int *swindex;
  int *swsum;
  double (*swpow)[SWPERT];
#endif
  int grid,nhist,blockmeas,totmeas,block;
  int *blockhist; /* [nhist] one block in Labik style */
  real *tothist; /* [nhist] histogram */ }
rdf = { 6 };

static real rdfcq;

#ifndef LONG
static vector shiftdr;
static
void meashist(struct HS_s *A,struct HS_s *B) /******************** meashist */
{
  real rr;
  int hr;

  rr=Sqr(A->r[0]-B->r[0]-shiftdr[0])
    +Sqr(A->r[1]-B->r[1]-shiftdr[1])
    +Sqr(A->r[2]-B->r[2]-shiftdr[2]);

  if (rr<rdfcq) {
    hr=(int)(sqrt(rr)*rdf.proggrid);
#ifndef PS
    if (hr<rdf.grid) {
      prt_("sphere overlap: r=%.16f sigma",sqrt(rr)/sigma);
      if ((sigmaq-rr)/sigmaq<EPS) {
        prt(" (still OK - fixed)");
        hr=rdf.grid; }
      else {
        prt_("\n%d",A-cfg); putv(A->r);
        prt_("%d",B-cfg); putv(B->r);
        ERROR(("sphere overlap")) } }
#endif    
    if (hr<rdf.nhist) rdf.blockhist[hr]++; } 
}
#endif

real measurerdf(void) /***************************************** measurerdf */
/* 
  HS: returns sum of r=[1,11/10] histograms multiplied by triangular weight
  PS: returns # of overlaps
*/
{
  real newsum,ret;
  int iw;

#ifdef LONG
  /* special version for measuring rdf over L/2 upto max. L */
  int i,j;
  double x,y,z;
  double xx,yy,zz;
  double rr;

  syncHS();
 
  loop (i,1,N) loop (j,0,i) {
    x=fabs(cfg[i].r[0]-cfg[j].r[0]); xx=L-x;
    y=fabs(cfg[i].r[1]-cfg[j].r[1]); yy=L-y;
    z=fabs(cfg[i].r[2]-cfg[j].r[2]); zz=L-z;
   
    x*=x; y*=y; z*=z;
    xx*=xx; yy*=yy; zz*=zz;
   
    if ( (rr=x+y+z)<rdfcq ) rdf.blockhist[(int)(sqrt(rr)*rdf.proggrid)]++;
    if ( (rr=xx+y+z)<rdfcq ) rdf.blockhist[(int)(sqrt(rr)*rdf.proggrid)]++;
    if ( (rr=x+yy+z)<rdfcq ) rdf.blockhist[(int)(sqrt(rr)*rdf.proggrid)]++;
    if ( (rr=xx+yy+z)<rdfcq ) rdf.blockhist[(int)(sqrt(rr)*rdf.proggrid)]++;
    if ( (rr=x+y+zz)<rdfcq ) rdf.blockhist[(int)(sqrt(rr)*rdf.proggrid)]++;
    if ( (rr=xx+y+zz)<rdfcq ) rdf.blockhist[(int)(sqrt(rr)*rdf.proggrid)]++;
    if ( (rr=x+yy+zz)<rdfcq ) rdf.blockhist[(int)(sqrt(rr)*rdf.proggrid)]++;
    if ( (rr=xx+yy+zz)<rdfcq ) rdf.blockhist[(int)(sqrt(rr)*rdf.proggrid)]++; }
#else
  /* normal version */
  intvector irA;
  struct nbr_s *nbr;
  struct HS_s *A,*B,*A0,**By,***Bx;
  int i,NHS=0,ii;
  int x,y,z0,z1;

  syncHS();

  loop (irA[0],0,ncell)
    loop (irA[1],0,ncell)
      loop (irA[2],0,ncell) looplist (A,A0=box[irA[0]][irA[1]][irA[2]]) {
#ifdef DEBUG
        if (memcmp(A->ir,irA,sizeof(irA)))
          ERROR(("box %d %d %d, sphere A->ir=%d %d %d",
                 irA[0],irA[1],irA[2],
		 A->ir[0],A->ir[1],A->ir[2]))
#endif
        NHS++;

        /* note: exact rounding A->r into A->ir needed, cf. advance() */

        nbr=&rdfnbrs[(int)((A->r[0]-irA[0])*RSUBCELL)]
                    [(int)((A->r[1]-irA[1])*RSUBCELL)]
                    [(int)((A->r[2]-irA[2])*RSUBCELL)];

        loop (x,nbr->fromx,nbr->tox) {
          if ( (ii=irA[0]+x)>=ncell ) shiftdr[0]=L,Bx=box[ii-ncell];
 	  else if (ii<0) shiftdr[0]=-L,Bx=box[ii+ncell];
	  else shiftdr[0]=0,Bx=box[ii];
          loop (y,nbr->x[x].fromy,nbr->x[x].toy) {
	    if ( (ii=irA[1]+y)>=ncell ) shiftdr[1]=L,By=Bx[ii-ncell];
	    else if (ii<0) shiftdr[1]=-L,By=Bx[ii+ncell];
	    else shiftdr[1]=0,By=Bx[ii];
	    z0=irA[2]+nbr->x[x].y[y].fromz;
	    z1=irA[2]+nbr->x[x].y[y].toz;
	    if (z0<0) {
	      shiftdr[2]=-L;
	      loop (ii,z0,0) looplist (B,By[ii+ncell]) meashist(A,B);
	      shiftdr[2]=0;
	      loop (ii,0,z1) looplist (B,By[ii]) meashist(A,B); }
	    else if (z1>ncell) {
	      shiftdr[2]=0;
	      loop (ii,z0,ncell) looplist (B,By[ii]) meashist(A,B);
	      shiftdr[2]=L;
	      loop (ii,ncell,z1) looplist (B,By[ii-ncell]) meashist(A,B); }
	    else {
              shiftdr[2]=0;
              loop (ii,z0,z1) looplist (B,By[ii]) meashist(A,B); } } }

        /* spheres in the same cell (quite rare for HS, possible for PS) */
        VO(shiftdr,=0)
        looplist (B,A->next) meashist(A,B); }

  if (N!=NHS) ERROR(("HS lost: NHS=%d != N=%d",NHS,N));
#endif

  newsum=0;
#ifdef PS
  loop (i,0,rdf.grid) newsum+=(real)rdf.blockhist[i];
  ret=newsum-rdf.oldsum;
#else    
  iw=rdf.grid/10;
  loop (i,rdf.grid,rdf.grid*11/10) newsum+=(real)rdf.blockhist[i]*iw--;
  ret=(newsum-rdf.oldsum)/(rdf.grid*N);
#endif
  rdf.oldsum=newsum;

#ifdef SWPERT
  {
    int swsum=0,ip;
    loop (iw,0,rdf.nsw) {
      loop (i,rdf.swindex[iw],rdf.swindex[iw+1]) swsum+=rdf.blockhist[i];
      StaSet(rdf.lag,2,8);
      loopto (ip,1,SWPERT) {
        double x=powi((double)(swsum-rdf.swsum[iw])/N,ip);
        StaAdd(string("sw[%d]^%d",iw+1,ip),x);
        rdf.swpow[iw][ip-1]+=x;
        StaSet(2,2,8); }
      rdf.swsum[iw]=swsum; }
  }
#endif

  rdf.blockmeas++;

  return ret;
}

real energy(void) /************************************************* energy */
/* 
  2*kinetic energy returned
*/
{
  real E=0;
  int i;

  loop (i,0,N) E+=SQR(cfg[i].v);

  return E;
}

void zeromomentum(void) /************************************* zeromomentum */
/* 
  sets the total momentum to zero
*/
{
  int i;
  vector m;

  VO(m,=0)
  loop (i,0,N) VV(m,+=cfg[i].v)

  prt("total momentum (%g %g %g) set to zero",m[0],m[1],m[2]);
 
  VO(m,/=N)
  loop (i,0,N) VV(cfg[i].v,-=m)
}

void writetotg(char *fn) /************************************** writetotg */
/* 
  total g printed to file
  (total g = sum of blocks incl. partly summed block)
*/
{
  int i;
  int meas=rdf.blockmeas+rdf.totmeas;
  FILE *f=fopen(fn,"wt");
  char *fmt="8.6";

  if (rdf.grid==1000 || rdf.grid==200) fmt="6.4";
  else if (rdf.grid==100 || rdf.grid==500) fmt="5.3";
 
  fmt=string("%%%sf %%8.6f %%.0f\n",fmt);
 
  fprintf(f,"\
# %d measurements N=%d rho=%g\n\
#  r     g(r)   hist\n",
         meas,N,rho);

#ifdef PS
  loop (i,0,rdf.nhist) 
#else
  loop (i,rdf.grid,rdf.nhist) 
#endif  
  { real r=(i+.5)/rdf.grid,dV=2*PI*(i*i+i+1./3)/Cub(rdf.grid);
    real hist=rdf.blockhist[i]+rdf.tothist[i];
   
    fprintf(f,fmt, r,hist/(rho*N*meas*dV),hist); }
  fclose(f);
}

void appendblockg(char *fn,int sumcoll) /********************* appendblockg */
/*
  appends one block of calculated g(r) to a Labik-style file
  adds block to the total histogram and resets block histogram to zero
  SWPERT: add blocks of perturbation term powers
*/
{
  int i;
  FILE *f=fopen(fn,"at");
  real q=rho*N*rdf.blockmeas;
  time_t ttt;

  rdf.block++; /* 1st block=1 */

  fprintf(f,"# %d %.9g\n",N,2*cubrt(rho/N));
  fprintf(f,"# %g 0\n",sumcoll/(real)rdf.blockmeas);
  fprintf(f,"# %d 0 0 %d\n",rdf.blockmeas,rdf.block);
  fprintf(f,"# %d %.9g\n",rdf.nhist-rdf.grid-1,1./rdf.grid);

#ifdef PS
  loop (i,0,rdf.nhist)
#else
  loop (i,rdf.grid,rdf.nhist)
#endif
  { real r=(i+.5)/rdf.grid,dV=2*PI*(i*i+i+1./3)/Cub(rdf.grid);
   
    fprintf(f,"%d\t%.7g\t%9.7f\t%d",
            i-rdf.grid,r,rdf.blockhist[i]/(q*dV),
            rdf.blockhist[i]); 

#ifdef SWPERT
    if (i-rdf.grid<rdf.nsw) {
      int ii=i-rdf.grid,ip;

      real a=rdf.swpow[ii][0]/rdf.blockmeas;
      real b=rdf.swpow[ii][1]/rdf.blockmeas;
      real c=rdf.swpow[ii][2]/rdf.blockmeas;
#if SWPERT>3
      real d=rdf.swpow[ii][3]/rdf.blockmeas;
#if SWPERT>4
      real e=rdf.swpow[ii][4]/rdf.blockmeas;
#if SWPERT>5
      real f=rdf.swpow[ii][5]/rdf.blockmeas;
#if SWPERT>6
#error SWPERT>6 not supported
#endif
#endif
#endif
#endif

    fprintf(f,"\t%20.16g",a);
    fprintf(f,"\t%20.16g",(powi(a,2)/2-b/2)*N);
    fprintf(f,"\t%20.16g",(powi(a,3)/3-a*b/2+c/6)*N*N);
#if SWPERT>3
    fprintf(f,"\t%20.16g",(powi(a,4)/4-powi(a,2)*b/2+a*c/6+powi(b,2)/8-d/24)*N*N*N);
#if SWPERT>4
    fprintf(f,"\t%20.16g",(powi(a,5)/5-powi(a,3)*b/2+powi(a,2)*c/6+a*powi(b,2)/4-a*d/24-b*c/12+e/120)*N*N*N*N);
#if SWPERT>5
    fprintf(f,"\t%20.16g",(powi(a,6)/6-powi(a,4)*b/2+powi(a,3)*c/6+3*powi(a,2)*powi(b,2)/8-powi(a,2)*d/24-a*b*c/6+a*e/120-powi(b,3)/24+b*d/48+powi(c,2)/72-f/720)*N*N*N*N*N);
#endif
#endif
#endif
      rdf.swsum[ii]=0;
      loop (ip,0,SWPERT) rdf.swpow[ii][ip]=0; }
#endif

    fprintf(f,"\n");

    rdf.tothist[i]+=rdf.blockhist[i];   
    rdf.blockhist[i]=0; }

  time(&ttt);
  prt_("%s block %d, %d measurements appended @ %s",
       fn,rdf.block,rdf.blockmeas,ctime(&ttt));
  if (out!=stdout)
    fprintf(stderr,"%s block %d, %d measurements appended @ %s",
            fn,rdf.block,rdf.blockmeas,ctime(&ttt));

  fflush(out);

  rdf.totmeas+=rdf.blockmeas;
  rdf.blockmeas=0;
  rdf.oldsum=0;

  fclose(f);
}

real setenergy(real E) /***************************************** setenergy */
/* 
  multiply all velocities by the same factor to reach 2*energy = E
  ratio returned
*/
{
  int i,k;
  real cfgE=energy();
  real ratio=sqrt(E/cfgE);

  loop (i,0,N) 
    loop (k,0,DIM) 
      cfg[i].v[k] *= ratio;
 
  prt("oldE=%.14g, newE=%.14g",cfgE,E);
  prt("rescaling velocities %.16f times",ratio);

#ifdef DEBUG
  put(energy())
#endif
  return ratio;
}

void updatewarning(real updateratio) /************************ updateratio */
{
  static real slide=1;
  static int nslide,warned;

  slide=.9*slide+updateratio*0.1;
  if (nslide++>10) if (slide<0.2 || slide>2) 
    if (!warned++)
      WARNING(("Possibly inefficient update ratio (%g), check cutoff",slide))
}

void slicewarning(void) /************************************ slicewarning */
{
  struct event_s *l;
  int it,n=0,nlong=0;
  static real slide=10,longslide=5;
  static int nslide,warned,longwarned;

  loop (it,it0,it0+3) looplist (l,tlist[it]) n++;
  looplist (l,longt) nlong++;
       
  slide=.9*slide+n/25.;
  longslide=.9*longslide+nlong*.1;
  if (nslide++>10) {
#ifdef SW
    /* for swmd.c */
    if (slide<2 || slide>100) {
      if (!warned++)
        WARNING(("Possibly inefficient # of events in a time slice (%g)\n\
*** check timeunit",slide)) }
    if (longslide<0.02 || longslide>20) {
      if (!longwarned++)
        WARNING(("Possibly inefficient # of events in the last time slice (%g)\n\
*** check Nlist and/or timeunit",longslide)) }
#else
    if (slide<2 || slide>100) {
      if (!warned++)
        WARNING(("Inefficient # of events in a time slice (%g)\n\
*** check variables slice and E",slide)) }
    if (longslide<0.02 || longslide>20) {
      if (!longwarned++)
        WARNING(("Inefficient # of events in the last time slice (%g)\n\
*** check Nlist, slice, and/or E",longslide)) }
#endif
    }
}
