void ovltest(char *title) /**************************************** ovltest */
/* 
  fool-proof sphere overlap test (inefficient!)
*/
{
 int i,j;
 vector dr;
 real rr,err;
 int novl=0;

 if (title) prt_("t=%g ovltest %s ...",t,title);
 loop (i,0,N) {
   vector ri;

   VVV(ri,=cfg[i].r,+(t-cfg[i].t)*cfg[i].v)
   loop (j,0,i) {
     vector rj;

     VVV(rj,=cfg[j].r,+(t-cfg[j].t)*cfg[j].v)
     dr[0]=Lh-fabs(Lh-fabs(ri[0]-rj[0]));
     dr[1]=Lh-fabs(Lh-fabs(ri[1]-rj[1]));
     dr[2]=Lh-fabs(Lh-fabs(ri[2]-rj[2]));
     rr=SQR(dr);
     if (rr<sigmaq) {
#ifdef PS     
       novl++;
#else
       err=(rr-sigmaq)/sigmaq;
       if (fabs(err)>DEBUG) ERROR(("\
OVERLAP %d = %g %g %g, %d = %g %g %g\n\
t=%g r=%.16f sigma  err=%g",
        i,cfg[i].r[0],cfg[i].r[1],cfg[i].r[2],
        j,cfg[j].r[0],cfg[j].r[1],cfg[j].r[2],
        t,sqrt(rr)/sigma,err)) 
#endif        
        } } }
#ifdef PS
  prt(" %d overlaps (fool-proof test)",novl);
#else  
  if (title) prt(" OK");
#endif 
}

void prtsphere(struct HS_s *A) /********************************* prtsphere */
/* 
  prints sphere information and checks whether it is correctly in its cell
*/
{
 if (A) {
   intvector ir;

   loop (ir[0],0,ncell)
     loop (ir[1],0,ncell)
       loop (ir[2],0,ncell)
         if (box[ir[0]][ir[1]][ir[2]]==A) goto OK;
   ir[0]=ir[1]=ir[2]=-1;
 OK:
   prt("%8x i=%d t=%g r=%.5f %.5f %.5f (%d %d %d) = box[%d][%d][%d]",
       A, A-cfg,A->t,
       A->r[0],A->r[1],A->r[2],
       (int)(A->r[0]), 
       (int)(A->r[1]), 
       (int)(A->r[2]),ir[0],ir[1],ir[2]); }
 else
   prt("NULL sphere");
}

void checklist(char *title,int p) /****************************** checklist */
/* 
  checks internal consistency of tlist (cycles)
*/
{
 int it,xx=0;

again:

 if (p) prt_("%-12s:",title);

 loopto (it,it0,it1) {
   int s=0;
   struct event_s *l;

   looplist (l,it==it1?longt:tlist[it])
     if (++s>=999999) { xx++; break; }
   if (p) prt_("%c%6d",it==it1?':':' ',s); }
 if (p) _n
 
 if (xx && p) ERROR(("cycle in list"))

 if (xx) { p++; goto again; }
}
